/*
* HMG Virtual Grid Demo
* (c) 2003 Roberto Lopez
*
Demo preparado a partir de una rutina generada por Luis Vasquez de Octubre 25, 2011 .
y mejorada por Roberto Lopez.

Se pretende con este demo explotar las posibilidades del grid virtual y su funcionamiento.
Espero les sea de utilidad.

En este demo podrn encontrar lo siguiente.

Ordenar:
********
Se ordena en base al valor de la primera columna y se ejecuta el ordenamiento una vez que se ha editado
la ltima celda.  Se ordena como el browse indexado.

Ordenar por columna:
********************
Al hacer click sobre las columnas 1, 2  3 se ordenan los registros.

Insertar filas:
***************
Permite insertar una fila vacia en la posicion que se encuentre presionando la tecla Insert.	

Para acelerar el grid y evitar el parpadeo del Refresh
PaintDoubleBuffer := .T.

*/

#include <hmg.ch>
#include "hfcl.ch"

* When using virtual Grids you must avoid to use Item property and additem 
* method. It can generate unexpected results.

Function Main
	public aElem := {}
   PUBLIC rElem := {} 
   PUBLIC xOrden
   PUBLIC aAux := {}
	PUBLIC totcedes
   public pasador

   PRIVATE LSB_1, LSB_2, LSB_3, LSB_4, LSB_5, LSB_6, LSB_7
   PRIVATE totfil1, totfil2, totfil3, totfil4, totfil5, totfil6, totfil7
   STORE 0 TO 	totfil1, totfil2, totfil3, totfil4, totfil5, totfil6, totfil7
   
   SET DATE BRITISH
   SET DELETE OFF
   SET CENTURY ON
   SET TOOLTIPSTYLE BALLOON 
   SET TOOLTIPBACKCOLOR { 250, 250, 210}
   SET NAVIGATION EXTENDED
   SET CODEPAGE TO SPANISH	
   SET LANGUAGE TO SPANISH

   USE MUSICA ALIAS MUSICA NEW EXCLUSIVE
   
	 FOR I := 1 TO MUSICA->(RECCOUNt())
          MUSICA->(dbgoto(i))
          aadd( aElem, { MUSICA->CDNRO , MUSICA->TRACKNRO, MUSICA->ARTISTA, MUSICA->TEMA, MUSICA->COMPOSITOR ,MUSICA->ANIO , MUSICA->DURACION, MUSICA->(RECNO()) } )
	 NEXT i
    totcedes := MUSICA->(RECCOUNt())
    USE    
	
	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 1024 ;
		HEIGHT 550 ;
		TITLE 'VIRTUALGRID DEMO - Not Finished' ;
		MAIN 
		
		DEFINE MAIN MENU
			DEFINE POPUP 'File'
				MENUITEM "Additem" ACTION agregar()
				MENUITEM 'Insert' ACTION insertar_registro()
				MENUITEM 'Delete' ACTION borrar()
				MENUITEM 'Filter' ACTION INGRE_DATA() 
				SEPARATOR
				MENUITEM 'Clear Filters' ACTION ( BORRAR_GRID() , borrafiltro() )
				SEPARATOR
				MENUITEM 'Exit' ACTION form_1.release
			END POPUP
		END MENU

		@ 9,10 GRID Grid_0 ;
            WIDTH 665 ;
            HEIGHT 21 ;
            HEADERS {'CD N','Track','Artist','Name','Composser','Year','Length','Hidden'} ;
            WIDTHS {70, 70,120,120, 120, 70, 70, 0};
            COLUMNCONTROLS {{'TEXTBOX','TEXTBOX'}, {'TEXTBOX','CHARACTER'},{'TEXTBOX','CHARACTER'},{'TEXTBOX','CHARACTER'},{'TEXTBOX','CHARACTER'},{'TEXTBOX','CHARACTER'},{'TEXTBOX','NUMERIC'} };
            COLUMNVALID { 	{ || Grabar( This.Cellvalue ) },{ || Grabar( This.Cellvalue ) },{ || Grabar( This.Cellvalue ) },{ || Grabar( This.Cellvalue ) },{ || Grabar( This.Cellvalue ) },{ || Grabar( This.Cellvalue ) },{ || Grabar( This.Cellvalue ) }	}; 
            ON HEADCLICK { { || ordenar_columna(1) } , { || ordenar_columna(2) } , { || ordenar_columna(3)} , { || ordenar_columna(4) } , { || ordenar_columna(5) } , { || ordenar_columna(6) , { || ordenar_columna(7) } } };
            VIRTUAL ;
            ITEMCOUNT len( aElem );
            ON QUERYDATA QueryTest() ;
            ON DBLCLICK mostrar() ;	
            TOOLTIP 'Grid Virtual' ;
            JUSTIFY { GRID_JTFY_CENTER , GRID_JTFY_CENTER , GRID_JTFY_CENTER , GRID_JTFY_CENTER , GRID_JTFY_CENTER , GRID_JTFY_CENTER , GRID_JTFY_CENTER  } 
            
		@ 47,10 GRID Grid_1 ;
            WIDTH 665 ;
            HEIGHT 420 ;
            HEADERS {'CD N','Track','Artist','Name','Composser','Year','Length','Hidden'} ;
            WIDTHS {70, 70,120,120, 120, 70, 70, 0};
            COLUMNCONTROLS {{'TEXTBOX','TEXTBOX'}, {'TEXTBOX','CHARACTER'},{'TEXTBOX','CHARACTER'},{'TEXTBOX','CHARACTER'},{'TEXTBOX','CHARACTER'},{'TEXTBOX','CHARACTER'},{'TEXTBOX','NUMERIC'} };
            COLUMNVALID { 	{ || Grabar( This.Cellvalue ) },{ || Grabar( This.Cellvalue ) },{ || Grabar( This.Cellvalue ) },{ || Grabar( This.Cellvalue ) },{ || Grabar( This.Cellvalue ) },{ || Grabar( This.Cellvalue ) },{ || Grabar( This.Cellvalue ) }	}; 
            ON HEADCLICK { { || ordenar_columna(1) } , { || ordenar_columna(2) } , { || ordenar_columna(3)} , { || ordenar_columna(4) } };
            VIRTUAL ;
            ITEMCOUNT len( aElem );
            ON QUERYDATA QueryTest() ;
            ON DBLCLICK mostrar() ;	
            TOOLTIP 'Grid Virtual' ;
            JUSTIFY { GRID_JTFY_LEFT , GRID_JTFY_CENTER , GRID_JTFY_LEFT , GRID_JTFY_LEFT , GRID_JTFY_LEFT , GRID_JTFY_CENTER , GRID_JTFY_CENTER  } ;

       FORM_1.Grid_1.PaintDoubleBuffer := .T.     

      @  352, 700 LABEL LABEL_INFO1 VALUE 'Searched records:' AUTOSIZE FONT 'MS Shell Dlg' SIZE 9 BOLD FONTCOLOR { 0,64,128 } TRANSPARENT  CENTERALIGN 
      @  382, 700 LABEL LABEL_INFO2 VALUE 'Records match filters:' AUTOSIZE FONT 'MS Shell Dlg' SIZE 9 BOLD FONTCOLOR { 0,64,128 } TRANSPARENT  CENTERALIGN 

      @ 350,850 textbox ELEMENTOS_CONSULTADOS ; 
         WIDTH 100 ; 
         FONT "Arial" SIZE 10 ;
         BOLD ; 
         VALUE 0 ; 
         DISABLEDBACKCOLOR {218,229,243}  ;
         DISABLEDFONTCOLOR {0,  64,  128} ; 
         READONLY ;
         NUMERIC INPUTMASK '999,999,999' FORMAT 'E'

      @ 380,850 textbox ELEMENTOS_ENCONTRADOS ; 
         WIDTH 100 ; 
         FONT "Arial" SIZE 10 ;
         BOLD ; 
         VALUE 0 ; 
         DISABLEDBACKCOLOR {218,229,243}  ;
         DISABLEDFONTCOLOR {128, 0,  0} ; 
         READONLY ;         
         NUMERIC INPUTMASK '999,999,999' FORMAT 'E'

		@ 30 , 10 TEXTBOX PRIMERO ;
			WIDTH 71 ;
			HEIGHT 17 ;
         FONT "Arial" SIZE 09 ;
         BOLD ; 
         VALUE '<All>' ;
    		BACKCOLOR {255,255,255} ;
         FONTCOLOR {  0, 64,128} ;
         DISABLEDBACKCOLOR {218,229,243}  ;
         DISABLEDFONTCOLOR {221, 0, 0} ;
         MAXLENGTH 30 ;
         READONLY

		@ 30 , 83 TEXTBOX SEGUNDO ;
			WIDTH 68 ;
			HEIGHT 17 ;
         FONT "Arial" SIZE 09 ;
         BOLD ; 
         VALUE '<All>' ;
    		BACKCOLOR {255,255,255} ;
         FONTCOLOR {  0, 64,128} ;
         DISABLEDBACKCOLOR {218,229,243}  ;
         DISABLEDFONTCOLOR {221,   0,   0} ; 
         MAXLENGTH 30 ;
         READONLY

		@ 30 , 153 TEXTBOX TERCERO ;
			WIDTH 118 ;
			HEIGHT 17 ;
         FONT "Arial" SIZE 09 ;
         BOLD ; 
         VALUE '<All>' ;
    		BACKCOLOR {250,250,210} ;
         DISABLEDBACKCOLOR {218,229,243}  ;
         DISABLEDFONTCOLOR {221,   0,   0} ; 
         MAXLENGTH 30 ;
         READONLY

		@ 30 , 273 TEXTBOX CUARTO ;
			WIDTH 118 ;
			HEIGHT 17 ;
         FONT "Arial" SIZE 09 ;
         BOLD ; 
         VALUE '<All>' ;
    		BACKCOLOR {250,250,210} ;
         DISABLEDBACKCOLOR {218,229,243}  ;
         DISABLEDFONTCOLOR {221,   0,   0} ; 
         MAXLENGTH 30 ;
         READONLY

		@ 30 , 393 TEXTBOX QUINTO ;
			WIDTH 118 ;
			HEIGHT 17 ;
         FONT "Arial" SIZE 09 ;
         BOLD ; 
         VALUE '<All>' ;
    		BACKCOLOR {250,250,210} ;
         DISABLEDBACKCOLOR {218,229,243}  ;
         DISABLEDFONTCOLOR {221,   0,   0} ; 
         MAXLENGTH 30 ;
         READONLY

		@ 30 , 513 TEXTBOX SEXTO ;
			WIDTH 68 ;
			HEIGHT 17 ;
         FONT "Arial" SIZE 09 ;
         BOLD ; 
         VALUE '<All>' ;
    		BACKCOLOR {250,250,210} ;
         DISABLEDBACKCOLOR {218,229,243}  ;
         DISABLEDFONTCOLOR {221,   0,   0} ; 
         MAXLENGTH 30 ;
         READONLY

		@ 30 , 584 TEXTBOX SEPTIMO ;
			WIDTH 68 ;
			HEIGHT 17 ;
         FONT "Arial" SIZE 09 ;
         BOLD ; 
         VALUE '<All>' ;
    		BACKCOLOR {250,250,210} ;
         DISABLEDBACKCOLOR {218,229,243}  ;
         DISABLEDFONTCOLOR {221,0,0} ; 
         MAXLENGTH 30 ;
         READONLY
         
      @ 30, 656 BUTTON BUT_ACERO PICTURE "SEARCH4" WIDTH 17 HEIGHT 17 ACTION ( INGRE_DATA() )           
      
	END WINDOW

	CENTER WINDOW Form_1
	ON KEY DELETE OF Form_1 ACTION borrar()
	ON KEY INSERT OF form_1 ACTION Insertar_Registro()
	ON KEY ESCAPE OF form_1 ACTION form_1.release
	ACTIVATE WINDOW Form_1

Return

Procedure QueryTest()
	This.QueryData := aElem[ This.QueryRowIndex ][ This.QueryColIndex ]
Return


procedure mostrar
//	alert( hb_valtostr(aElem[ This.CellRowIndex ][ 1 ]) )
   MSGINFO(hb_valtostr(aElem[ This.CellRowIndex ][ 1 ]) + CHR(10) + "PUT HERE YOUR MODIFY DATA ROUTINE" , "NOTICE:") 
return

procedure Grabar( xValue )
	
	aElem[ This.CellRowIndex ][ This.CellColIndex ] := xValue
	
	if This.CellColIndex = 5
		
		ordenar_registros()
						
		form_1.grid_1.deleteallitems
		form_1.grid_1.refresh
				
	endif
		
return


procedure ordenar_registros()
	local aTemp 	:= aElem[ This.CellRowIndex ]
	local i:= 1
	
	* Tomo el valor de la celda la cual voy a ordenar
	
	xOrden = aElem[ This.CellRowIndex ][1]
	
	* Inicio el ciclo de comparacin.
	
	for i:= 1 to len( aElem )	
	
		if aElem[i][1] > xorden
		
			* 	Redimensiono la matriz para insertar 
			
			aSize( aElem, len( aElem )+1 )
						
			
			*	Inserto una fila a la matriz
			*	se supone que corre todos los registros siguientes
			*	a la fila siguiente.
			
			aIns( aElem, i )
			
			
			*	Asigno el valor ordenado a la fila insertada
			
			aElem[i] := aTemp
			
			*	Elimino la fila original
			
			aDel( aElem, ( This.CellRowIndex + 1 ) )
			
			*	Redimensiono el arreglo
			
			aSize( aElem, len( aElem )-1 )
			
			*	Asigno la posicion del registro al grid
			
			form_1.grid_1.value := i
			
			*	Termino el ciclo
			exit
			
		endif
		
	next

return

procedure ordenar_columna( ncol )
	local i:= 1, j := 1, p := form_1.grid_1.value
	local atemp
	
	for i= 1 to len( aElem )
		do events
		for j= 1 to len( aElem )
			do events
			if i <> j
				if aElem[ i ][ ncol ] < aElem[ j ][ nCol ]
					aTemp = aElem[ j ]
					aElem[ j ] = aElem[ i ]
					aElem[ i ] = aTemp
	            endif
	        endif
		next
	next
	
	Form_1.Grid_1.DeleteAllItems		       
	Actualizar_Contador()
	Form_1.Grid_1.Refresh
	Form_1.Grid_1.Value := p
return

procedure agregar
	*- Agrego una fila a la matriz
	aadd( aElem, { Date()+1, i, "Elemento "+alltrim(str(len(aElem))), .T., 1 } )
	
	*- Actualizo el contador del grid
	actualizar_contador()
	
	form_1.grid_1.value := len( aelem )
	
return

procedure borrar
	local npos := form_1.grid_1.value
	*- Elimino el registro del arreglo
	aDel( aElem, This.CellRowIndex )
	
	*- Redimensiono el arreglo.
	aSize( aElem, len( aElem )-1 )
	
	actualizar_contador()
	
	if npos > form_1.grid_1.itemcount
		npos = form_1.grid_1.itemcount
	endif
	form_1.grid_1.value := npos
		
return

procedure actualizar_contador

	*- Actualizo el grid sino causa error
	*- Adems, haciendo esta actualizacion al ordenar por columna refresca la vista
	*- sino no lo hace.
		
	form_1.grid_1.itemcount := len( aElem )

return

procedure ajustar
	form_1.grid_1.width := (form_1.width - form_1.grid_1.col) - 10
	form_1.grid_1.height:= ((form_1.height- form_1.grid_1.row )) - 60
return

procedure filtro
return

PROCEDURE borrafiltro
	Form_1.Grid_1.DeleteAllItems		       
	Actualizar_Contador()
	Form_1.Grid_1.Refresh
	Form_1.Grid_1.Value := 0
   
   USE MUSICA ALIAS MUSICA NEW EXCLUSIVE
// 	aElem := {}
   FORM_1.GRID_1.REFRESH
	FOR I := 1 TO totcedes
         MUSICA->(dbgoto(i))
         aadd( aElem, { MUSICA->CDNRO , MUSICA->TRACKNRO, MUSICA->ARTISTA, MUSICA->TEMA, MUSICA->COMPOSITOR ,MUSICA->ANIO , MUSICA->DURACION, MUSICA->(RECNO()) } )
   NEXT i
   USE
    
  	Actualizar_Contador()
 	Form_1.Grid_1.Refresh
	Form_1.Grid_1.Value := 0
   FORM_1.GRID_1.REFRESH
RETURN

PROCEDURE INSERTAR_REGISTRO
RETURN

procedure ejecuta_filtro1
	local xvalor := nil
	local ncol := 1
	totfil1 := 0
	xvalor = form_1.PRIMERO.value
   FORM_1.ELEMENTOS_CONSULTADOS.VALUE := FORM_1.grid_1.itemcount			
   
	if valtype( xvalor ) != NIL
		aAux := aElem
		aElem = {}
		
		for i:= 1 to len( aAux )
			if rat( UPPER(alltrim(xvalor)), alltrim(UPPER( hb_valtostr( aAux[ i ][ ncol ] ) ) ) ) != 0
				aadd( aElem, aAux[i] )
            totfil1 += 1
			endif
		next
		form_1.grid_1.deleteallitems
		actualizar_contador()
      FORM_1.ELEMENTOS_ENCONTRADOS.VALUE := FORM_1.grid_1.itemcount
	endif
   
   IF FORM_1.ELEMENTOS_ENCONTRADOS.VALUE == 0 .AND. TOTFIL1 == 0
      borrafiltro() 
      poner_a_cero()
   ENDIF
	
return

procedure ejecuta_filtro2
	local xvalor := nil
	local ncol := 2
	totfil2 := 0
   FORM_1.ELEMENTOS_CONSULTADOS.VALUE := FORM_1.grid_1.itemcount			
	
   xvalor = form_1.SEGUNDO.value
   IF (LEN(ALLTRIM(xvalor))) == 0
      RETURN
   ENDIF
			
	if valtype( xvalor ) != NIL
		aAux := aElem
		aElem = {}
		
		for i:= 1 to len( aAux )
			if rat( alltrim(UPPER(xvalor)), alltrim(UPPER( hb_valtostr( aAux[ i ][ ncol ] ) )) ) != 0
				aadd( aElem, aAux[i] )
           	totfil2 += 1
			endif
		next
		form_1.grid_1.deleteallitems
		actualizar_contador()
      FORM_1.ELEMENTOS_ENCONTRADOS.VALUE := FORM_1.grid_1.itemcount
	endif
   
   IF FORM_1.ELEMENTOS_ENCONTRADOS.VALUE == 0 .AND. TOTFIL1 == 0
      borrafiltro() 
      poner_a_cero()
   ENDIF
	
return

procedure ejecuta_filtro3
	local xvalor := nil
	local ncol := 3
	totfil3 := 0
   FORM_1.ELEMENTOS_CONSULTADOS.VALUE := FORM_1.grid_1.itemcount			
	
   xvalor = form_1.TERCERO.value
   
   IF (LEN(ALLTRIM(xvalor))) == 0
      RETURN
   ENDIF
			
	if valtype( xvalor ) != NIL
		aAux := aElem
		aElem = {}
		
		for i:= 1 to len( aAux )
			if rat( alltrim(UPPER(xvalor)), alltrim(UPPER( hb_valtostr( aAux[ i ][ ncol ] ) )) ) != 0
				aadd( aElem, aAux[i] )
           	totfil3 += 1
			endif
		next
		form_1.grid_1.deleteallitems
		actualizar_contador()
      FORM_1.ELEMENTOS_ENCONTRADOS.VALUE := FORM_1.grid_1.itemcount
	endif
   
   IF FORM_1.ELEMENTOS_ENCONTRADOS.VALUE == 0 .AND. TOTFIL1 == 0
      borrafiltro() 
      poner_a_cero()
   ENDIF
	
return

procedure ejecuta_filtro4
	local xvalor := nil
	local ncol := 4
	totfil4 := 0
   FORM_1.ELEMENTOS_CONSULTADOS.VALUE := FORM_1.grid_1.itemcount			

   xvalor = form_1.CUARTO.value

   IF (LEN(ALLTRIM(xvalor))) == 0
      RETURN
   ENDIF
   
	if valtype( xvalor ) != NIL
		aAux := aElem
		aElem = {}
		
		for i:= 1 to len( aAux )
			if rat( alltrim(UPPER(xvalor)), alltrim(UPPER( hb_valtostr( aAux[ i ][ ncol ] ) )) ) != 0
				aadd( aElem, aAux[i] )
         	totfil4 += 1
			endif
		next
		form_1.grid_1.deleteallitems
		actualizar_contador()
      FORM_1.ELEMENTOS_ENCONTRADOS.VALUE := FORM_1.grid_1.itemcount
	endif
   
   IF FORM_1.ELEMENTOS_ENCONTRADOS.VALUE == 0 .AND. TOTFIL1 == 0
      borrafiltro() 
      poner_a_cero()
   ENDIF
	
return

procedure ejecuta_filtro5
	local xvalor := nil
	local ncol := 5
	totfil5 := 0
   FORM_1.ELEMENTOS_CONSULTADOS.VALUE := FORM_1.grid_1.itemcount			

   xvalor = form_1.QUINTO.value

   IF (LEN(ALLTRIM(xvalor))) == 0
      RETURN
   ENDIF
   
	if valtype( xvalor ) != NIL
		aAux := aElem
		aElem = {}
		
		for i:= 1 to len( aAux )
			if rat( alltrim(UPPER(xvalor)), alltrim(UPPER( hb_valtostr( aAux[ i ][ ncol ] ) )) ) != 0
				aadd( aElem, aAux[i] )
          	totfil5 += 1
			endif
		next
		form_1.grid_1.deleteallitems
		actualizar_contador()
      FORM_1.ELEMENTOS_ENCONTRADOS.VALUE := FORM_1.grid_1.itemcount
	endif
   
   IF FORM_1.ELEMENTOS_ENCONTRADOS.VALUE == 0 .AND. TOTFIL1 == 0
      borrafiltro() 
      poner_a_cero()
   ENDIF
	
return

procedure ejecuta_filtro6
	local xvalor := nil
	local ncol := 6
	totfil6 := 0
   FORM_1.ELEMENTOS_CONSULTADOS.VALUE := FORM_1.grid_1.itemcount			

   xvalor = form_1.SEXTO.value

   IF (LEN(ALLTRIM(xvalor))) == 0
      RETURN
   ENDIF
   
	if valtype( xvalor ) != NIL
		aAux := aElem
		aElem = {}
		
		for i:= 1 to len( aAux )
			if rat( alltrim(UPPER(xvalor)), alltrim(UPPER( hb_valtostr( aAux[ i ][ ncol ] ) )) ) != 0
				aadd( aElem, aAux[i] )
         	totfil6 += 1
			endif
		next
		form_1.grid_1.deleteallitems
		actualizar_contador()
      FORM_1.ELEMENTOS_ENCONTRADOS.VALUE := FORM_1.grid_1.itemcount
	endif
   
   IF FORM_1.ELEMENTOS_ENCONTRADOS.VALUE == 0 .AND. TOTFIL1 == 0
      borrafiltro() 
      poner_a_cero()
   ENDIF
	
return

procedure ejecuta_filtro7
	local xvalor := nil
	local ncol := 7
	totfil7 := 0
   FORM_1.ELEMENTOS_CONSULTADOS.VALUE := FORM_1.grid_1.itemcount			

   xvalor = form_1.SEPTIMO.value

   IF (LEN(ALLTRIM(xvalor))) == 0
      RETURN
   ENDIF
   
	if valtype( xvalor ) != NIL
		aAux := aElem
		aElem = {}
		
		for i:= 1 to len( aAux )
			if rat( alltrim(UPPER(xvalor)), alltrim(UPPER( hb_valtostr( aAux[ i ][ ncol ] ) )) ) != 0
				aadd( aElem, aAux[i] )
          	totfil7 += 1
			endif
		next
		form_1.grid_1.deleteallitems
		actualizar_contador()
      FORM_1.ELEMENTOS_ENCONTRADOS.VALUE := FORM_1.grid_1.itemcount
	endif
   
   IF FORM_1.ELEMENTOS_ENCONTRADOS.VALUE == 0 .AND. TOTFIL1 == 0
      borrafiltro() 
      poner_a_cero()
   ENDIF
	
return





PROCEDURE SetColumnWIDTH
   FOR i = 1 TO GetProperty ("Form_1","Grid_0","ColumnCount")
       SetProperty ("Form_1","Grid_0","ColumnWIDTH", i, GRID_WIDTH_AUTOSIZE)
       SetProperty ("FORM_1","Grid_1","ColumnWIDTH", i, GRID_WIDTH_AUTOSIZEHEADER)       
   NEXT
RETURN


PROCEDURE GetColumnWIDTH
   aWidth := {}
   FOR i = 1 TO GetProperty ("Form_1","Grid_0","ColumnCount")
       AADD (aWidth, GetProperty ("Form_1","Grid_0","ColumnWIDTH", i)) 
   NEXT
   MsgDebug (aWidth)
RETURN


PROCEDURE ACTUALI_COL
   aWidth := {}
   FOR i = 1 TO GetProperty ("Form_1","Grid_1","ColumnCount")
       AADD (aWidth, GetProperty ("Form_1","Grid_1","ColumnWIDTH", i)) 
   NEXT
   FOR i = 1 TO GetProperty ("Form_1","Grid_1","ColumnCount")
       // SetProperty ("Form_1","Grid_2","ColumnWIDTH", i, 100 ) 
       Form_1.Grid_2.ColumnWIDTH(i) := FORM_1.GRID_1.COLUMNWIDTH(i)
       // <ParentWindowName>.<GridControlName>.ColumnWIDTH            ( nColIndex )  := [ nColumnWidth ] 
   NEXT
   FORM_1.LABEL_1.SETFOCUS
RETURN

PROCEDURE INGRE_DATA

	DEFINE WINDOW DATABUSQ ;
      AT 189, 715 ; 
		WIDTH 300 HEIGHT 250 ; 
		TITLE '' ;
      MODAL ; 
      NOSIZE ;
      NOSYSMENU ;
      NOCAPTION ;
      BACKCOLOR {218,229,243} 

   DRAW RECTANGLE IN WINDOW DATABUSQ AT 0, 0 TO 250 , 300 PENCOLOR {0,64,128} PENWIDTH 3  FILLCOLOR {218,229,243}

    @ 10, 10 FRAME FRAME_CONCE1 ;
          CAPTION " Multisearch options" ;
          WIDTH 280      ;
	       HEIGHT 175 	;
          TRANSPARENT

      @ 195, 10 BUTTON BUT_RESTORE CAPTION "Restore last multisearch items" WIDTH 280 HEIGHT 20 FONT 'MS Shell Dlg' SIZE 9 ACTION ( MSGINFO('NOT IMPLEMENTED YET','NOTICE:') )           
      @ 220, 20 BUTTON BUT_CLEAN   CAPTION "Clear multisearch items"        WIDTH 120 HEIGHT 20 FONT 'MS Shell Dlg' SIZE 9 ACTION ( BORRAR_GRID() )
      @ 220, 160 BUTTON BUT_QUIT    CAPTION "Quit multisearch options"      WIDTH 120 HEIGHT 20 FONT 'MS Shell Dlg' SIZE 9 ACTION ( DATABUSQ.RELEASE )
   
      @  31, 20 LABEL LABEL_SB1 VALUE 'CD Id. number' AUTOSIZE FONT 'MS Shell Dlg' SIZE 9 BOLD FONTCOLOR { 0,64,128 } TRANSPARENT  CENTERALIGN 
      @  51, 20 LABEL LABEL_SB2 VALUE 'Track number'  AUTOSIZE FONT 'MS Shell Dlg' SIZE 9 BOLD FONTCOLOR { 0,64,128 } TRANSPARENT  CENTERALIGN 
      @  71, 20 LABEL LABEL_SB3 VALUE 'Artist / Interpreter'  AUTOSIZE FONT 'MS Shell Dlg' SIZE 9 BOLD FONTCOLOR { 0,64,128 } TRANSPARENT  CENTERALIGN 
      @  91, 20 LABEL LABEL_SB4 VALUE 'Song Name'  AUTOSIZE FONT 'MS Shell Dlg' SIZE 9 BOLD FONTCOLOR { 0,64,128 } TRANSPARENT  CENTERALIGN 
      @ 111, 20 LABEL LABEL_SB5 VALUE 'Composser'  AUTOSIZE FONT 'MS Shell Dlg' SIZE 9 BOLD FONTCOLOR { 0,64,128 } TRANSPARENT  CENTERALIGN 
      @ 131, 20 LABEL LABEL_SB6 VALUE 'Compossed Year'  AUTOSIZE FONT 'MS Shell Dlg' SIZE 9 BOLD FONTCOLOR { 0,64,128 } TRANSPARENT  CENTERALIGN 
      @ 151, 20 LABEL LABEL_SB7 VALUE 'Track elapse'  AUTOSIZE FONT 'MS Shell Dlg' SIZE 9 BOLD FONTCOLOR { 0,64,128 } TRANSPARENT  CENTERALIGN 
   
      @ 30 , 160 TEXTBOX DATA1 ;
			WIDTH 120 ;
			HEIGHT 17 ;
         FONT 'MS Shell Dlg' SIZE 9 ;
         VALUE '' ;
    		BACKCOLOR {250,250,210} ;
         MAXLENGTH 30 ;
         ON CHANGE ( data_search() ) 

		@ 50 , 160 TEXTBOX DATA2 ;
			WIDTH 120 ;
			HEIGHT 17 ;
         FONT 'MS Shell Dlg' SIZE 9 ;
         VALUE '' ;
    		BACKCOLOR {250,250,210} ;
         MAXLENGTH 30 ;
         ON CHANGE ( data_search() ) 
         
		@ 70 , 160 TEXTBOX DATA3 ;
			WIDTH 120 ;
			HEIGHT 17 ;
         FONT 'MS Shell Dlg' SIZE 9 ;
         VALUE '' ;
    		BACKCOLOR {250,250,210} ;
         MAXLENGTH 30 ;
         ON CHANGE ( data_search() ) 

		@ 90 , 160 TEXTBOX DATA4 ;
			WIDTH 120 ;
			HEIGHT 17 ;
         FONT 'MS Shell Dlg' SIZE 9 ;
         VALUE '' ;
    		BACKCOLOR {250,250,210} ;
         MAXLENGTH 30 ;
         ON CHANGE ( data_search() ) 
         
		@ 110 , 160 TEXTBOX DATA5 ;
			WIDTH 120 ;
			HEIGHT 17 ;
         FONT 'MS Shell Dlg' SIZE 9 ;
         VALUE '' ;
    		BACKCOLOR {250,250,210} ;
         MAXLENGTH 30 ;
         ON CHANGE ( data_search() ) 

		@ 130 , 160 TEXTBOX DATA6 ;
			WIDTH 120 ;
			HEIGHT 17 ;
         FONT 'MS Shell Dlg' SIZE 9 ;
         VALUE '' ;
    		BACKCOLOR {250,250,210} ;
         MAXLENGTH 30 ;
         ON CHANGE ( data_search() ) 

		@ 150 , 160 TEXTBOX DATA7 ;
			WIDTH 120 ;
			HEIGHT 17 ;
         FONT 'MS Shell Dlg' SIZE 9 ;
         VALUE '' ;
    		BACKCOLOR {250,250,210} ;
         MAXLENGTH 30 ;
         ON CHANGE ( data_search() ) 
      
   END WINDOW

	ACTIVATE WINDOW DATABUSQ

Return      

PROCEDURE DATA_SEARCH
IF LEN(DATABUSQ.DATA1.VALUE) > 0
   FORM_1.PRIMERO.DISABLEDFONTCOLOR.VALUE := {221,0,0}
   MODIFY CONTROL PRIMERO OF FORM_1 VALUE DATABUSQ.DATA1.VALUE
   LSB_1 := DATABUSQ.DATA1.VALUE
   ejecuta_filtro1()
ENDIF   
IF LEN(DATABUSQ.DATA2.VALUE) > 0
   FORM_1.SEGUNDO.DISABLEDFONTCOLOR.VALUE := {221,0,0}
   MODIFY CONTROL SEGUNDO OF FORM_1 VALUE DATABUSQ.DATA2.VALUE
   LSB_2 := DATABUSQ.DATA2.VALUE
   ejecuta_filtro2()
ENDIF   
IF LEN(DATABUSQ.DATA3.VALUE) > 0
   FORM_1.TERCERO.DISABLEDFONTCOLOR.VALUE := {221,0,0}
   MODIFY CONTROL TERCERO OF FORM_1 VALUE DATABUSQ.DATA3.VALUE
   LSB_3 := DATABUSQ.DATA3.VALUE
   ejecuta_filtro3()
ENDIF   
IF LEN(DATABUSQ.DATA4.VALUE) > 0
   FORM_1.CUARTO.DISABLEDFONTCOLOR.VALUE := {221,0,0}
   MODIFY CONTROL CUARTO OF FORM_1 VALUE DATABUSQ.DATA4.VALUE
   LSB_4 := DATABUSQ.DATA4.VALUE
   ejecuta_filtro4()
ENDIF   
IF LEN(DATABUSQ.DATA5.VALUE) > 0
   FORM_1.QUINTO.DISABLEDFONTCOLOR.VALUE := {221,0,0}
   MODIFY CONTROL QUINTO OF FORM_1 VALUE DATABUSQ.DATA5.VALUE
   LSB_5 := DATABUSQ.DATA5.VALUE
   ejecuta_filtro5()
ENDIF   
IF LEN(DATABUSQ.DATA6.VALUE) > 0
   FORM_1.SEXTO.DISABLEDFONTCOLOR.VALUE := {221,0,0}
   MODIFY CONTROL SEXTO OF FORM_1 VALUE DATABUSQ.DATA6.VALUE
   LSB_6 := DATABUSQ.DATA6.VALUE
   ejecuta_filtro6()
ENDIF   
IF LEN(DATABUSQ.DATA7.VALUE) > 0
   FORM_1.SEPTIMO.DISABLEDFONTCOLOR.VALUE := {221,0,0}
   MODIFY CONTROL SEPTIMO OF FORM_1 VALUE DATABUSQ.DATA7.VALUE
   LSB_7 := DATABUSQ.DATA7.VALUE
   ejecuta_filtro7()
ENDIF   

RETURN


PROCEDURE RECARGAR_BUSQUEDA
RESTORE FROM ULB ADDITIVE
RETURN

PROCEDURE GUARDAR_BUSQUEDA
LSB_1 := DATABUSQ.DATA1.VALUE
LSB_2 := DATABUSQ.DATA2.VALUE
LSB_3 := DATABUSQ.DATA3.VALUE
LSB_4 := DATABUSQ.DATA4.VALUE
LSB_5 := DATABUSQ.DATA5.VALUE
LSB_6 := DATABUSQ.DATA6.VALUE
LSB_7 := DATABUSQ.DATA7.VALUE
RETURN

PROCEDURE poner_a_cero
DATABUSQ.DATA1.VALUE := ''
DATABUSQ.DATA2.VALUE := ''
DATABUSQ.DATA3.VALUE := ''
DATABUSQ.DATA4.VALUE := ''
DATABUSQ.DATA5.VALUE := ''
DATABUSQ.DATA6.VALUE := ''
DATABUSQ.DATA7.VALUE := ''
FORM_1.PRIMERO.VALUE := '<All>'
FORM_1.SEGUNDO.VALUE := '<All>'
FORM_1.TERCERO.VALUE := '<All>'
FORM_1.CUARTO.VALUE  := '<All>'
FORM_1.QUINTO.VALUE  := '<All>'
FORM_1.SEXTO.VALUE   := '<All>'
FORM_1.SEPTIMO.VALUE := '<All>'
FORM_1.ELEMENTOS_CONSULTADOS.VALUE := 0
FORM_1.ELEMENTOS_ENCONTRADOS.VALUE := 0
RETURN

PROCEDURE BORRAR_GRID
	local xvalor := nil
	local ncol := 1
	totfil1 := 0
   FORM_1.ELEMENTOS_CONSULTADOS.VALUE := FORM_1.grid_1.itemcount			

   xvalor = 'ZZZzzz'

   IF (LEN(ALLTRIM(xvalor))) == 0
      RETURN
   ENDIF
   
	if valtype( xvalor ) != NIL
		aAux := aElem
		aElem = {}
		
		for i:= 1 to len( aAux )
			if rat( alltrim(UPPER(xvalor)), alltrim(UPPER( hb_valtostr( aAux[ i ][ ncol ] ) )) ) != 0
				aadd( aElem, aAux[i] )
         	totfil4 += 1
			endif
		next
		form_1.grid_1.deleteallitems
		actualizar_contador()
      FORM_1.ELEMENTOS_ENCONTRADOS.VALUE := FORM_1.grid_1.itemcount
	endif
   
   IF FORM_1.ELEMENTOS_ENCONTRADOS.VALUE == 0 .AND. TOTFIL1 == 0
      borrafiltro() 
      FORM_1.PRIMERO.VALUE := '<All>'
      FORM_1.SEGUNDO.VALUE := '<All>'
      FORM_1.TERCERO.VALUE := '<All>'
      FORM_1.CUARTO.VALUE  := '<All>'
      FORM_1.QUINTO.VALUE  := '<All>'
      FORM_1.SEXTO.VALUE   := '<All>'
      FORM_1.SEPTIMO.VALUE := '<All>'
      FORM_1.ELEMENTOS_CONSULTADOS.VALUE := 0
      FORM_1.ELEMENTOS_ENCONTRADOS.VALUE := 0
   ENDIF
	
return
